unit iCalc;

interface

uses
	Classes;

function	CalcStrings(ASrc, ADst: TStrings): Extended;

implementation

uses
	Windows, SysUtils, jstrm, ExpParser, iUtils;

var
	Work1: TStringList;
	Work2: TStringList;
	Work3: TStringList;

function	CalcStrings(ASrc, ADst: TStrings): Extended;
const
	DISP_LEN = 20;
var
	i, j: integer;
    Text: string;
    ResLine: Extended;
    Ticks: Cardinal;
begin
	Ticks := GetTickCount;

	//Sp𔼊pɕϊ
    Work1.Text := JUniCase(ASrc.Text);

	//ȊO
    Work2.Clear;
	for i := 0 to Work1.Count - 1 do
    begin
		Text := Work1[i];
		for j := 1 to Length(Text) do
        begin
        	if not (Text[j] in ['0'..'9','.','*','/','+','-','(',')']) then Text[j] := ' ';
        end;
    	Work2.Add(Text);
    end;
	Work1.Text := Work2.Text;

	//s폜E]ȋ󔒍폜
    Work2.Clear;
	for i := 0 to Work1.Count - 1 do
    begin
		Text := Trim(Work1[i]);
		if Text <> '' then Work2.Add(Text);
    end;
	Work1.Text := Work2.Text;

    //Ȃ番
    Work2.Clear;
	for i := 0 to Work1.Count - 1 do
    begin
		Work3.CommaText := Work1[i];
		for j := 0 to Work3.Count - 1 do
        begin
			Work2.Add(Work3[j]);
        end;                                 
    end;
	Work1.Text := Work2.Text;

    //
	Result := 0;
    Work2.Clear;

    //vZ
	for i := 0 to Work1.Count - 1 do
    begin
		try
            Text := Work1[i];
			try
				ResLine := Calculate(Text);
                Text := Format('%10.6f', [ResLine]);
                Result := Result + ResLine;
            except
                Text := '[' + Text + ']';
            end;

        except
			on E:Exception do Text := E.Message;
        end;
		Work2.Add(TitledString('', Text, DISP_LEN));
	end;

    //\
	Work2.Add(StringOfChar('-', DISP_LEN));
	Text := FloatToStr(Result);
	Work2.Add(TitledString('A.', Text, DISP_LEN));
	Work2.Add(StringOfChar('-', DISP_LEN));

    //oߎԁE
    Ticks := GetTickCount - Ticks;
	Work2.Insert(0, StringOfChar('-', DISP_LEN));
	Work2.Insert(0, Format('%s(%fsec)', [NowTimeToStr(), Ticks / 1000]));
	Work2.Insert(0, StringOfChar('-', DISP_LEN));

    //
    ADst.Text := Work2.Text;
end;

initialization
	Work1 := TStringList.Create;
	Work2 := TStringList.Create;
	Work3 := TStringList.Create;
finalization
    Work1.Free;
    Work2.Free;
    Work3.Free;

end.
